proc start_name_map { } {
    set win "name_map"
    toplevel .${win}
    wm title .${win} "Name lookup mapping"
    set nameservers [ exec /export/home/jberning/perl/uxctl/get-namesvrs.pl ]
    set numservers [ llength $nameservers ]
    
    frame .${win}.header
    frame .${win}.body
    frame .${win}.control

    pack .${win}.header .${win}.body .${win}.control -in .${win} -side top -padx 1 -pady 1 -expand 1

    for { set i 0 } { $i < $numservers } { incr i } {
	button .${win}.server$i -text "[ lindex $nameservers $i ]" -command "setup_search [ lindex $nameservers $i ]"
	pack .${win}.server$i -in .${win}.body -side left -expand 1 -padx 1 -pady 1
	raise .${win}.server$i
    }

    message .${win}.servermsg -text "DNS Nameserver lookup" -width 20c
    message .${win}.servermsg2 -text "Nameserver selection" -width 20c

    pack .${win}.servermsg .${win}.servermsg2 -in .${win}.header -side top -padx 1 -pady 1 -expand 1
    raise .${win}.servermsg
    raise .${win}.servermsg2

    button .${win}.ok -text DONE -command "destroy .${win}"
    pack .${win}.ok -in .${win}.control -side top -expand 1

}

proc setup_search { ns } {
    set base [ join [ split $ns "." ] "-" ]
    set win "${base}-nameserver-window"

    toplevel .${win}

    wm title .${win} "Nameserver lookup"

    frame .${win}.header
    frame .${win}.body
    frame .${win}.footer

    pack .${win}.header .${win}.body .${win}.footer -in .${win} -side top -expand 1 -padx 1 -pady 1

    message .${win}.hdrmsg1 -text "DNS Name lookup services" -width 20c
    message .${win}.hdrmsg2 -text "Default server: $ns" -width 20c

    pack .${win}.hdrmsg1 .${win}.hdrmsg2 -in .${win}.header -side top -expand 1

    button .${win}.done -text DONE -command "destroy .${win}"
    pack .${win}.done -in .${win}.footer -side top -expand 1 -padx 1 -pady 1

    frame .${win}.entry -relief raised
    frame .${win}.result -relief raised

    pack .${win}.entry .${win}.result -in .${win}.body -side left -expand 1

    text .${win}.lookupresults -bd 2 -yscrollcommand ".${win}.scrollresult set"
    scrollbar .${win}.scrollresult -command ".${win}.lookupresults yview"
    pack .${win}.scrollresult -side right -fill y -in .${win}.result
    pack .${win}.lookupresults -side left -in .${win}.result

    frame .${win}.entrytop
    frame .${win}.entrybot
    pack .${win}.entrytop .${win}.entrybot -in .${win}.entry -side top -expand 1 -fill y -pady 3

    set lookuparg ""

    message .${win}.lookuplbl -text "Hostname or IP address to look up:" -width 20c
    entry .${win}.lookupent -relief sunken -bd 2 -textvariable lookuparg
    pack .${win}.lookuplbl .${win}.lookupent -in .${win}.entrytop -side top -expand 1

    frame .${win}.recordl
    frame .${win}.recordr

    pack .${win}.recordl .${win}.recordr -in .${win}.entrybot -side left -expand 1 -fill x -anchor n

    foreach recordtype [ split "A MX NS CNAME PTR HINFO SOA TXT WKS" " " ] {
	button .${win}.record${recordtype} -text "${recordtype} record" -command "do_lookup ${recordtype} ${ns}"
    }
    foreach rectype [ split "A NS PTR SOA WKS" " "] {
	pack .${win}.record${rectype} -in .${win}.recordl -side top -padx 2 -pady 2 -expand 1 -fill x
	raise .${win}.record${rectype}
    }
    foreach rectype [ split "MX CNAME HINFO TXT" " " ] {
	pack .${win}.record${rectype} -in .${win}.recordr -side top -padx 2 -pady 2 -expand 1 -fill x
	raise .${win}.record${rectype}
    }	

}

proc do_lookup { rectype server } {
    set base [ join [ split $server "." ] "-" ]
    set win "${base}-nameserver-window"

    global lookuparg
    #  Following command possibly Solaris dependent.  Be sure to check your man pages for the nslookup command.
    catch { exec nslookup -type=${rectype} $lookuparg $server } result
    .${win}.lookupresults insert end $result
    .${win}.lookupresults insert end "\n---------------------------------\n"
}




